//+------------------------------------------------------------------+
//|                                                HMA color nrp.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrYellow
#property indicator_color2  clrLimeGreen
#property indicator_color3  clrLimeGreen
#property indicator_color4  clrOrange
#property indicator_color5  clrOrange
#property strict

//
//
//
//
//

enum enDisplay
{
   en_lin,  // Display line
   en_lid,  // Display lines with dots
   en_dot   // Display dots
};

extern int                HMA_Period      = 15;             // Hma Period to use
extern ENUM_APPLIED_PRICE HMA_PriceType   = 0;              // Hma Price to use
extern ENUM_MA_METHOD     HMA_Method      = MODE_LWMA;      // Hma Method
extern enDisplay          DisplayType     = en_lin;         // Display type
extern int                LinesWidth      = 3;              // Lines width (when lines are included in display)
extern bool               alertsOn        = true;           // Turn alerts on?
extern bool               alertsOnCurrent = false;          // Alerts on still open bar?
extern bool               alertsMessage   = true;           // Alerts should show popup message?
extern bool               alertsSound     = false;          // Alerts should play a sound?
extern bool               alertsEmail     = false;          // Alerts should send email?
extern bool               alertsPushNotif = false;          // Alerts should send notification?
extern int                UpArrowSize     = 2;              // Up Arrow size
extern int                DnArrowSize     = 2;              // Down Arrow size
extern int                UpArrowCode     = 159;            // Up Arrow code
extern int                DnArrowCode     = 159;            // Down arrow code
extern double             UpArrowGap      = 0.5;            // Up Arrow gap        
extern double             DnArrowGap      = 0.5;            // Dn Arrow gap
extern color              UpArrowColor    = clrLimeGreen;   // Up Arrow Color
extern color              DnArrowColor    = clrOrange;      // Down Arrow Color

//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double arrowu[];
double arrowd[];
double buffer[];
double trend[];
int HalfPeriod;
int HullPeriod;

//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------

int init()
{
   IndicatorBuffers(9);
   int lstyle = DRAW_LINE;      if (DisplayType==en_dot) lstyle = DRAW_NONE;
   int astyle = DRAW_ARROW;     if (DisplayType<en_lid)  astyle = DRAW_NONE;
   SetIndexBuffer(0, buffer0); SetIndexStyle(0,lstyle,EMPTY,LinesWidth);
   SetIndexBuffer(1, buffer1); SetIndexStyle(1,lstyle,EMPTY,LinesWidth);
   SetIndexBuffer(2, buffer2); SetIndexStyle(2,lstyle,EMPTY,LinesWidth);
   SetIndexBuffer(3, buffer3); SetIndexStyle(3,lstyle,EMPTY,LinesWidth);
   SetIndexBuffer(4, buffer4); SetIndexStyle(4,lstyle,EMPTY,LinesWidth);
   SetIndexBuffer(5, arrowu);  SetIndexStyle(5, astyle,0,UpArrowSize,UpArrowColor); SetIndexArrow(5,UpArrowCode);
   SetIndexBuffer(6, arrowd);  SetIndexStyle(6, astyle,0,DnArrowSize,DnArrowColor); SetIndexArrow(6,DnArrowCode);
   SetIndexBuffer(7,buffer);
   SetIndexBuffer(8,trend);
   
   HMA_Period = (int)fmax(2,HMA_Period);
   HalfPeriod = (int)floor(HMA_Period/2);
   HullPeriod = (int)floor(MathSqrt(HMA_Period));
   
   IndicatorShortName("HMA("+(string)HMA_Period+")");
return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit = fmin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //
   
   if (trend[limit] ==  1) CleanPoint(limit,buffer1,buffer2);
   if (trend[limit] == -1) CleanPoint(limit,buffer3,buffer4);
   for(i=limit; i>=0; i--) buffer[i]=iMA(NULL,0,HalfPeriod,0,HMA_Method,HMA_PriceType,i)*2-iMA(NULL,0,HMA_Period,0,HMA_Method,HMA_PriceType,i);
   for(i=limit; i>=0; i--)
   {
      buffer0[i] = iMAOnArray(buffer,0,HullPeriod,0,HMA_Method,i);
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
      buffer3[i] = EMPTY_VALUE;
      buffer4[i] = EMPTY_VALUE;
      arrowu[i]  = EMPTY_VALUE;
      arrowd[i]  = EMPTY_VALUE;
      if (i<Bars-1)
      {
         trend[i] = trend[i+1];            
            if (buffer0[i]>buffer0[i+1]) trend[i] =  1; 
            if (buffer0[i]<buffer0[i+1]) trend[i] = -1; 
            if (trend[i] ==  1) PlotPoint(i,buffer1,buffer2,buffer0);
            if (trend[i] == -1) PlotPoint(i,buffer3,buffer4,buffer0);
      }
      if (i<Bars-1 && trend[i]!=trend[i+1])
      {
         if (trend[i] ==  1) arrowu[i] = fmin(buffer0[i],Low[i] )-iATR(NULL,0,15,i)*UpArrowGap;
         if (trend[i] == -1) arrowd[i] = fmax(buffer0[i],High[i])+iATR(NULL,0,15,i)*DnArrowGap;
       } 
   }
 
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("sloping up");
      else  doAlert("sloping down");       
   }  
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Hull ",doWhat);
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol()," Hull "),message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}


